GNU bug report logs - #10907
24.0.94; Updating display of Customize buffer

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Stephen Berman <stephen.berman@HIDDEN>; dated Tue, 28 Feb 2012 13:12:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 3 Mar 2012 17:04:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 03 12:04:44 2012
Received: from localhost ([127.0.0.1]:60195 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S3sNw-0002Gp-7o
	for submit <at> debbugs.gnu.org; Sat, 03 Mar 2012 12:04:44 -0500
Received: from mailout-de.gmx.net ([213.165.64.23]:36258)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S3sNi-0002GQ-Nu
	for 10907 <at> debbugs.gnu.org; Sat, 03 Mar 2012 12:04:33 -0500
Received: (qmail invoked by alias); 03 Mar 2012 17:03:52 -0000
Received: from i59F5683C.versanet.de (EHLO escher.home) [89.245.104.60]
	by mail.gmx.net (mp041) with SMTP; 03 Mar 2012 18:03:52 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX19MPbReNx1MvWPJ+wrCecEoLn3jIAxL8imBQ5j/lS
	C2h0TxOOiMjvSG
From: Stephen Berman <stephen.berman@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN> <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN>
Date: Sat, 03 Mar 2012 18:03:50 +0100
In-Reply-To: <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Tue, 28 Feb 2012 21:06:59 -0500")
Message-ID: <87r4x9ehvt.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Y-GMX-Trusted: 0
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, Andreas Schwab <schwab@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

--=-=-=
Content-Type: text/plain

On Tue, 28 Feb 2012 21:06:59 -0500 Stefan Monnier <monnier@HIDDEN> wrote:

>> Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
>> defcustom in a running Emacs?
>
> Agreed that there should be some way to have a defcustom type that is
> a bit more dynamic: no need to completely reevaluate the whole
> expression, but being able to have a dynamic set of `choice's would
> be helpful.

It turns out that, at least for my use case, completely reevaluating the
whole expression in fact DTRT -- see the attached file.  Admittedly,
elegant it isn't, and AFAIK this is virtually never done (I guess that's
why it didn't occur to me when I asked the above question) -- but other
than inelegance, is there a problem with doing this?

Steve Berman


--=-=-=
Content-Type: text/x-emacs-lisp
Content-Disposition: attachment; filename=srb.el
Content-Description: test updating defcustom

(defgroup srb nil
  "srb group.")

(defcustom srb-dir "~/srb/"
  "Directory of files whose names are members of `srb-file-list'."
  :type 'directory
  :group 'srb)

(defvar srb-file-list (if (file-exists-p srb-dir)
			  (directory-files srb-dir nil
					   "^[^.]+")) ; Don't include "." or ".."
  "List of names of files in `srb-dir'.")

(defcustom srb-selected-file (car srb-file-list)
  "A selected file name from `srb-file-list'."
  :type `(radio ,@(mapcar (lambda (x) (list 'const x)) srb-file-list))
  :group 'srb)

(defun srb-reevaluate-defcustom ()
  "Reevaluate defcustom `srb-selected-file'."
  (eval (defcustom srb-selected-file (car srb-file-list)
	  "A selected file name from `srb-file-list'."
	  :type `(radio ,@(mapcar (lambda (x) (list 'const x)) srb-file-list))
	  :group 'srb)))

(defun srb-add-file ()
  "Add a file to `srb-dir' and update variables."
  (interactive)
  (unless (file-exists-p srb-dir)
    (make-directory srb-dir))
  (let ((file (read-from-minibuffer "Enter a file name: ")))
    (with-current-buffer (get-buffer-create file)
      (erase-buffer)
      (write-region (point-min) (point-max)
		    (concat srb-dir file) nil 'nomessage nil t)
      (kill-buffer file)))
  (setq srb-file-list (directory-files srb-dir nil "^[^.]+"))
  (custom-set-default 'srb-selected-file (symbol-value 'srb-selected-file))
  (srb-reevaluate-defcustom))

(defun srb-delete-file ()
  "Delete a file from `srb-dir' and update variables."
  (interactive)
  (let ((files (directory-files srb-dir nil "^[^.]+")))
    (if (and (file-exists-p srb-dir) (> (length files) 0))
	(let ((file (completing-read "Enter a file name: " files nil t)))
	  (when (yes-or-no-p (format "Confirm you want to delete file %s " file))
	    (delete-file (concat srb-dir file))
	    (setq srb-file-list (directory-files srb-dir nil "^[^.]+"))
	    (custom-set-default 'srb-selected-file
				(symbol-value 'srb-selected-file))
	    (srb-reevaluate-defcustom)
	    (message "File %s deleted" file)))
      (error "There are no files to delete"))))

(provide 'srb)

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 1 Mar 2012 02:43:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 29 21:43:35 2012
Received: from localhost ([127.0.0.1]:56563 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2vzS-00020x-VO
	for submit <at> debbugs.gnu.org; Wed, 29 Feb 2012 21:43:35 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:24560)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1S2vzG-00020b-Kl
	for 10907 <at> debbugs.gnu.org; Wed, 29 Feb 2012 21:43:23 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AicFAKU/KE9FxJvl/2dsb2JhbACBX5x7eYhwnhmGGQSGUJRJhAs
X-IronPort-AV: E=Sophos;i="4.73,1,1325480400"; 
   d="scan'208";a="165304667"
Received: from 69-196-155-229.dsl.teksavvy.com (HELO pastel.home)
	([69.196.155.229])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	29 Feb 2012 21:42:59 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id 5DC3758F5C; Wed, 29 Feb 2012 21:42:58 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
Message-ID: <jwv7gz5yrjn.fsf-monnier+emacs@HIDDEN>
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN> <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN>
	<y7ty29l8yr.fsf@HIDDEN>
Date: Wed, 29 Feb 2012 21:42:58 -0500
In-Reply-To: <y7ty29l8yr.fsf@HIDDEN> (Glenn Morris's message of
	"Wed, 29 Feb 2012 14:45:32 -0500")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.93 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, Stephen Berman <stephen.berman@HIDDEN>,
	Andreas Schwab <schwab@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

>> but being able to have a dynamic set of `choice's would be helpful.
> When might you want to use such a thing, as opposed to having :type a
> static list that encompasses all possible valid settings?

In the email to which you respond, I mention completion-styles, since
these can refer to styles that are provided by external packages.

> I can only see it being harmful.  Eg if you want to compute the :type
> based on whether some external utility is installed on the system, you
> could end up with saved settings in ~/.emacs that suddenly become
> invalid (wrong type) if said utility gets removed from the system.

Just because there are scenarios where you can bump into bugs doesn't
mean it can't be very useful.  E.g. types such as `function' also accept
a set of values that depends on what's installed, yet it hasn't proved
to be a problem.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 19:46:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 29 14:46:17 2012
Received: from localhost ([127.0.0.1]:56417 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2pTU-00015K-0P
	for submit <at> debbugs.gnu.org; Wed, 29 Feb 2012 14:46:17 -0500
Received: from fencepost.gnu.org ([208.118.235.10]:50633)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <rgm@HIDDEN>) id 1S2pTI-00014t-1T
	for 10907 <at> debbugs.gnu.org; Wed, 29 Feb 2012 14:45:56 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.71)
	(envelope-from <rgm@HIDDEN>)
	id 1S2pSv-0005Yz-1v; Wed, 29 Feb 2012 14:45:33 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN> <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN>
X-Spook: INSCOM credit card Montenegro SDI Crypto AG Honduras
X-Ran: }(Oa0>aL?uwvs?v']:)F$r_,C"ppr@#_Umsuw^)WkfQDg/,Jg@MU}|~R.Iq%QD"?)Fsy0y
X-Hue: blue
X-Debbugs-No-Ack: yes
X-Attribution: GM
Date: Wed, 29 Feb 2012 14:45:32 -0500
Message-ID: <y7ty29l8yr.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: Stefan Monnier wrote: > but being able to have a
	dynamic set
	of `choice's would be helpful. When might you want to use such a thing,
	as
	opposed to having :type a static list that encompasses all possible
	valid settings? [...] 
	Content analysis details:   (2.0 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	1.3 UNRESOLVED_TEMPLATE    Headers contain an unresolved template
	2.7 RCVD_IN_PSBL           RBL: Received via a relay in PSBL
	[208.118.235.10 listed in psbl.surriel.com]
	-0.0 T_RP_MATCHES_RCVD Envelope sender domain matches handover relay
	domain
	-0.0 SPF_PASS               SPF: sender matches SPF record
	-1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
	[score: 0.0000]
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, Stephen Berman <stephen.berman@HIDDEN>,
	Andreas Schwab <schwab@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Stefan Monnier wrote: > but being able to have a dynamic set
    of `choice's would be helpful. When might you want to use such a thing, as
    opposed to having :type a static list that encompasses all possible valid
    settings? [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.3 UNRESOLVED_TEMPLATE    Headers contain an unresolved template
  2.7 RCVD_IN_PSBL           RBL: Received via a relay in PSBL
                             [208.118.235.10 listed in psbl.surriel.com]
 -0.0 T_RP_MATCHES_RCVD      Envelope sender domain matches handover relay
                             domain
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
                             [score: 0.0000]

Stefan Monnier wrote:

> but being able to have a dynamic set of `choice's would be helpful.

When might you want to use such a thing, as opposed to having :type a
static list that encompasses all possible valid settings?

I can only see it being harmful. Eg if you want to compute the :type
based on whether some external utility is installed on the system, you
could end up with saved settings in ~/.emacs that suddenly become
invalid (wrong type) if said utility gets removed from the system.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 12:27:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 29 07:27:29 2012
Received: from localhost ([127.0.0.1]:55232 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2icz-0005JT-KA
	for submit <at> debbugs.gnu.org; Wed, 29 Feb 2012 07:27:29 -0500
Received: from mailout-de.gmx.net ([213.165.64.22]:40713)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2icd-0005Id-T9
	for 10907 <at> debbugs.gnu.org; Wed, 29 Feb 2012 07:27:18 -0500
Received: (qmail invoked by alias); 29 Feb 2012 12:26:48 -0000
Received: from i59F55A45.versanet.de (EHLO escher.home) [89.245.90.69]
	by mail.gmx.net (mp016) with SMTP; 29 Feb 2012 13:26:48 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX19kQ4lzBxVki56Uk8ZwlvYF8FVfo7wxQjvjhVPjVc
	3Am8eccp6nZPSc
From: Stephen Berman <stephen.berman@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN> <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN>
	<m2k436c8ms.fsf@HIDDEN>
Date: Wed, 29 Feb 2012 13:26:47 +0100
In-Reply-To: <m2k436c8ms.fsf@HIDDEN> (Andreas Schwab's message of "Wed, 29
	Feb 2012 10:05:15 +0100")
Message-ID: <87d38xbzaw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Y-GMX-Trusted: 0
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

On Wed, 29 Feb 2012 10:05:15 +0100 Andreas Schwab <schwab@HIDDEN> wrote:

> Stefan Monnier <monnier@HIDDEN> writes:
>
>>> Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
>>> defcustom in a running Emacs?
>>
>> Agreed that there should be some way to have a defcustom type that is
>> a bit more dynamic: no need to completely reevaluate the whole
>> expression, but being able to have a dynamic set of `choice's would
>> be helpful.
>
> Define a widget derived from menu-choice with custom :match and
> :validate methods.

Thanks for the suggestion; I'll try taking a stab at it, but with my
level of competence and available time, it may take a while, if I
succeed at all (if anyone else beats me to the punch, please let know).

Steve Berman




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 12:21:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 29 07:21:33 2012
Received: from localhost ([127.0.0.1]:55228 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2iXE-0005Az-RD
	for submit <at> debbugs.gnu.org; Wed, 29 Feb 2012 07:21:33 -0500
Received: from mailout-de.gmx.net ([213.165.64.23]:53629)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2iX0-0005AP-R0
	for 10907 <at> debbugs.gnu.org; Wed, 29 Feb 2012 07:21:20 -0500
Received: (qmail invoked by alias); 29 Feb 2012 12:20:59 -0000
Received: from i59F55A45.versanet.de (EHLO escher.home) [89.245.90.69]
	by mail.gmx.net (mp019) with SMTP; 29 Feb 2012 13:20:59 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX1/5j/o9RtL5X+suTukC7ynvTfvtXlIenpHIV4JW/3
	ECmiWxQJJSVovo
From: Stephen Berman <stephen.berman@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN> <83wr76cmqw.fsf@HIDDEN>
Date: Wed, 29 Feb 2012 13:20:57 +0100
In-Reply-To: <83wr76cmqw.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 29 Feb
	2012 06:00:23 +0200")
Message-ID: <87hay9bzkm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Y-GMX-Trusted: 0
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, schwab@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

On Wed, 29 Feb 2012 06:00:23 +0200 Eli Zaretskii <eliz@HIDDEN> wrote:

>> From: Stephen Berman <stephen.berman@HIDDEN>
>> Date: Tue, 28 Feb 2012 19:33:16 +0100
>> Cc: 10907 <at> debbugs.gnu.org
>> 
>> On Tue, 28 Feb 2012 19:00:15 +0100 Andreas Schwab <schwab@HIDDEN> wrote:
>> 
>> > *Note (elisp) Customization Types::
>> >
>> >        You specify the customization type in `defcustom' with the `:type'
>> >     keyword.  The argument of `:type' is evaluated, but only once when the
>> >     `defcustom' is executed, so it isn't useful for the value to vary.
>> 
>> Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
>> defcustom in a running Emacs?  It would be very useful.
>
> There's custom-reevaluate-setting, but I'm not sure it will do what
> you want.

Unfortunately it doesn't (I pointed that out in my OP, assuming I was
using it properly).

Steve Berman




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 09:05:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 29 04:05:50 2012
Received: from localhost ([127.0.0.1]:55104 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2fTo-0000ZR-KT
	for submit <at> debbugs.gnu.org; Wed, 29 Feb 2012 04:05:50 -0500
Received: from mail-out.m-online.net ([212.18.0.10]:34175)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <whitebox@HIDDEN>) id 1S2fTb-0000Z1-RR
	for 10907 <at> debbugs.gnu.org; Wed, 29 Feb 2012 04:05:37 -0500
Received: from frontend1.mail.m-online.net (frontend1.mail.intern.m-online.net
	[192.168.8.180])
	by mail-out.m-online.net (Postfix) with ESMTP id 3TyW7w5yCdz3hhTT;
	Wed, 29 Feb 2012 10:05:16 +0100 (CET)
X-Auth-Info: Owg1g1t05PqYzRAF2a2nKvlN5mA04V817sz7dpkGZZY=
Received: from igel.home (ppp-88-217-121-106.dynamic.mnet-online.de
	[88.217.121.106])
	by mail.mnet-online.de (Postfix) with ESMTPA id 3TyW7w5zZqz4KK8s;
	Wed, 29 Feb 2012 10:05:16 +0100 (CET)
Received: by igel.home (Postfix, from userid 501)
	id EDD76CA299; Wed, 29 Feb 2012 10:05:15 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN> <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN>
X-Yow: Okay..  I'm going home to write the ``I HATE RUBIK's CUBE
	HANDBOOK FOR DEAD CAT LOVERS''..
Date: Wed, 29 Feb 2012 10:05:15 +0100
In-Reply-To: <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Tue, 28 Feb 2012 21:06:59 -0500")
Message-ID: <m2k436c8ms.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, Stephen Berman <stephen.berman@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

Stefan Monnier <monnier@HIDDEN> writes:

>> Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
>> defcustom in a running Emacs?
>
> Agreed that there should be some way to have a defcustom type that is
> a bit more dynamic: no need to completely reevaluate the whole
> expression, but being able to have a dynamic set of `choice's would
> be helpful.

Define a widget derived from menu-choice with custom :match and
:validate methods.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 03:58:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 22:58:48 2012
Received: from localhost ([127.0.0.1]:54978 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2agi-0000L2-An
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 22:58:48 -0500
Received: from mtaout23.012.net.il ([80.179.55.175]:62943)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1S2agU-0000Kb-UG
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 22:58:36 -0500
Received: from conversion-daemon.a-mtaout23.012.net.il by
	a-mtaout23.012.net.il (HyperSendmail v2007.08) id
	<0M0400C00YXBX300@HIDDEN> for
	10907 <at> debbugs.gnu.org; Wed, 29 Feb 2012 05:58:16 +0200 (IST)
Received: from HOME-C4E4A596F7 ([77.124.119.92]) by a-mtaout23.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0M0400CSVZ13TS71@HIDDEN>;
	Wed, 29 Feb 2012 05:58:16 +0200 (IST)
Date: Wed, 29 Feb 2012 06:00:23 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
In-reply-to: <87fwdu7qqb.fsf@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stephen Berman <stephen.berman@HIDDEN>
Message-id: <83wr76cmqw.fsf@HIDDEN>
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN>
X-Spam-Score: -1.2 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, schwab@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.2 (-)

> From: Stephen Berman <stephen.berman@HIDDEN>
> Date: Tue, 28 Feb 2012 19:33:16 +0100
> Cc: 10907 <at> debbugs.gnu.org
> 
> On Tue, 28 Feb 2012 19:00:15 +0100 Andreas Schwab <schwab@HIDDEN> wrote:
> 
> > *Note (elisp) Customization Types::
> >
> >        You specify the customization type in `defcustom' with the `:type'
> >     keyword.  The argument of `:type' is evaluated, but only once when the
> >     `defcustom' is executed, so it isn't useful for the value to vary.
> 
> Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
> defcustom in a running Emacs?  It would be very useful.

There's custom-reevaluate-setting, but I'm not sure it will do what
you want.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 02:07:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 21:07:27 2012
Received: from localhost ([127.0.0.1]:54942 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2Ywx-0006G5-Ic
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 21:07:27 -0500
Received: from ironport2-out.teksavvy.com ([206.248.154.181]:63060)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1S2Ywm-0006FS-Nk
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 21:07:17 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AicFAKU/KE9FxJvl/2dsb2JhbACBX5x7eYhwnhmGGQSGUJRJhAs
X-IronPort-AV: E=Sophos;i="4.73,1,1325480400"; 
   d="scan'208";a="165064611"
Received: from 69-196-155-229.dsl.teksavvy.com (HELO pastel.home)
	([69.196.155.229])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	28 Feb 2012 21:07:00 -0500
Received: by pastel.home (Postfix, from userid 20848)
	id AD44B58F5C; Tue, 28 Feb 2012 21:06:59 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Stephen Berman <stephen.berman@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
Message-ID: <jwvipiq2y5p.fsf-monnier+emacs@HIDDEN>
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<87fwdu7qqb.fsf@HIDDEN>
Date: Tue, 28 Feb 2012 21:06:59 -0500
In-Reply-To: <87fwdu7qqb.fsf@HIDDEN> (Stephen Berman's message of "Tue,
	28 Feb 2012 19:33:16 +0100")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.93 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, Andreas Schwab <schwab@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

> Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
> defcustom in a running Emacs?

Agreed that there should be some way to have a defcustom type that is
a bit more dynamic: no need to completely reevaluate the whole
expression, but being able to have a dynamic set of `choice's would
be helpful.
I don't know Custom enough to be sure that it doesn't exist, so if it
does, please someone change the :type of completion-styles to make use
of it.  If it doesn't, well, patches welcome,


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 29 Feb 2012 01:02:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 20:02:03 2012
Received: from localhost ([127.0.0.1]:54915 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2Xvf-0004ml-D8
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 20:02:03 -0500
Received: from rcsinet15.oracle.com ([148.87.113.117]:48975)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1S2XvK-0004m7-Sk
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 20:01:52 -0500
Received: from ucsinet22.oracle.com (ucsinet22.oracle.com [156.151.31.94])
	by rcsinet15.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id q1T11J4l030879
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Wed, 29 Feb 2012 01:01:23 GMT
Received: from acsmt357.oracle.com (acsmt357.oracle.com [141.146.40.157])
	by ucsinet22.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	q1T11HbA003427
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Wed, 29 Feb 2012 01:01:18 GMT
Received: from abhmt104.oracle.com (abhmt104.oracle.com [141.146.116.56])
	by acsmt357.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	q1T11Hmn024881; Tue, 28 Feb 2012 19:01:17 -0600
Received: from dradamslap1 (/10.159.42.251)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Tue, 28 Feb 2012 17:01:17 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Andreas Schwab'" <schwab@HIDDEN>
References: <87vcmr6r9a.fsf@HIDDEN>
	<m2sjhvax4o.fsf@HIDDEN><87obsj6l48.fsf@HIDDEN>
	<m2linmc1og.fsf@HIDDEN><87k4367spn.fsf@HIDDEN>
	<m2hayabzyo.fsf@HIDDEN><5D50FB57830546E49BA986F7932928F5@HIDDEN>
	<m2obsia6yr.fsf@HIDDEN>
Subject: RE: bug#10907: 24.0.94; Updating display of Customize buffer
Date: Tue, 28 Feb 2012 17:01:11 -0800
Message-ID: <718B660A694245509BF866FDAC5C371C@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <m2obsia6yr.fsf@HIDDEN>
Thread-Index: Acz2bmGH8YqB/AdoRQy32CZVVp7I8gADwLGw
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
X-Source-IP: ucsinet22.oracle.com [156.151.31.94]
X-CT-RefId: str=0001.0A090206.4F4D78E3.0031,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, 'Stephen Berman' <stephen.berman@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

> This is about defcustom, which is not a user-level command.

My bad.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 23:12:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 18:12:26 2012
Received: from localhost ([127.0.0.1]:54799 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2WDZ-0002Du-UV
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 18:12:26 -0500
Received: from mail-out.m-online.net ([212.18.0.10]:51395)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <whitebox@HIDDEN>) id 1S2WDN-0002DH-Rh
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 18:12:15 -0500
Received: from frontend1.mail.m-online.net (frontend1.mail.intern.m-online.net
	[192.168.8.180])
	by mail-out.m-online.net (Postfix) with ESMTP id 3TyFzK0kTvz3hhbb;
	Wed, 29 Feb 2012 00:11:56 +0100 (CET)
X-Auth-Info: Bn7JpSMoCmItDzV9DwMJ5Fs0HavGI+Pc1+dFU9nF29Y=
Received: from igel.home (ppp-93-104-151-115.dynamic.mnet-online.de
	[93.104.151.115])
	by mail.mnet-online.de (Postfix) with ESMTPA id 3TyFzK26Xcz4KK7T;
	Wed, 29 Feb 2012 00:11:57 +0100 (CET)
Received: by igel.home (Postfix, from userid 501)
	id 8B5E4CA299; Wed, 29 Feb 2012 00:11:56 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: "Drew Adams" <drew.adams@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
	<5D50FB57830546E49BA986F7932928F5@HIDDEN>
X-Yow: - if it GLISTENS, gobble it!!
Date: Wed, 29 Feb 2012 00:11:56 +0100
In-Reply-To: <5D50FB57830546E49BA986F7932928F5@HIDDEN> (Drew Adams's
	message of "Tue, 28 Feb 2012 14:11:22 -0800")
Message-ID: <m2obsia6yr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org, 'Stephen Berman' <stephen.berman@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

"Drew Adams" <drew.adams@HIDDEN> writes:

> At the least there seems to be an Emacs-manual doc bug here.

Rubbish.  This is about defcustom, which is not a user-level command.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 22:33:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 17:33:50 2012
Received: from localhost ([127.0.0.1]:54766 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2VcE-0001LH-Cg
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:33:50 -0500
Received: from mailout-de.gmx.net ([213.165.64.23]:37038)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2Vc2-0001Kp-1O
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:33:38 -0500
Received: (qmail invoked by alias); 28 Feb 2012 18:33:17 -0000
Received: from i59F564CF.versanet.de (EHLO escher.home) [89.245.100.207]
	by mail.gmx.net (mp071) with SMTP; 28 Feb 2012 19:33:17 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX1893yFUcFw9d0RJHSCxsC1Gi+W5zqLrezpMHcO5LS
	x16FjRQAamnvmG
From: Stephen Berman <stephen.berman@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN> <m2hayabzyo.fsf@HIDDEN>
Date: Tue, 28 Feb 2012 19:33:16 +0100
In-Reply-To: <m2hayabzyo.fsf@HIDDEN> (Andreas Schwab's message of "Tue, 28
	Feb 2012 19:00:15 +0100")
Message-ID: <87fwdu7qqb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Y-GMX-Trusted: 0
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

On Tue, 28 Feb 2012 19:00:15 +0100 Andreas Schwab <schwab@HIDDEN> wrote:

> *Note (elisp) Customization Types::
>
>        You specify the customization type in `defcustom' with the `:type'
>     keyword.  The argument of `:type' is evaluated, but only once when the
>     `defcustom' is executed, so it isn't useful for the value to vary.

Ah, thanks.  I feared as much.  Is there really no way to reevaluate a
defcustom in a running Emacs?  It would be very useful.

Steve Berman




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 22:27:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 17:27:11 2012
Received: from localhost ([127.0.0.1]:54755 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2VVn-0001B6-7u
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:27:11 -0500
Received: from mailout-de.gmx.net ([213.165.64.22]:38040)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2VVb-0001Ad-8O
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:27:00 -0500
Received: (qmail invoked by alias); 28 Feb 2012 15:19:58 -0000
Received: from i59F564CF.versanet.de (EHLO escher.home) [89.245.100.207]
	by mail.gmx.net (mp036) with SMTP; 28 Feb 2012 16:19:58 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX19ElmxUlU9EtohWhywZJ/rX2BbwmkkLletxaAM+nO
	4aGkXS0fkQQkHK
From: Stephen Berman <stephen.berman@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
Date: Tue, 28 Feb 2012 16:19:51 +0100
In-Reply-To: <m2sjhvax4o.fsf@HIDDEN> (Andreas Schwab's message of "Tue, 28
	Feb 2012 14:46:47 +0100")
Message-ID: <87obsj6l48.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Y-GMX-Trusted: 0
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

On Tue, 28 Feb 2012 14:46:47 +0100 Andreas Schwab <schwab@HIDDEN> wrote:

> Stephen Berman <stephen.berman@HIDDEN> writes:
>
>> 7. In the Customize buffer hide and then re-show the value of
>> srb-selected-file; now the Customize buffer shows this:
>>
>>  Srb Selected File: "file1"
>>      State: STANDARD. (mismatch)
>>      A selected file name from `srb-file-list'.
>
> The current value does not match any of the empty set of choices.

Do you mean that Custom thinks srb-file-list is still empty?  If so, and
if I add a check, that fixes the mismatch, but not the display.
Specifically, if I change the definition of srb-selected-file to this:

(defcustom srb-selected-file (car srb-file-list)
  "A selected file name from `srb-file-list'."
  :type (if srb-file-list
	    `(radio ,@(mapcar (lambda (x) (list 'const x)) srb-file-list))) 
  :group 'srb)

then when srb-dir is empty or nonexistant, the Custom buffer shows this:

 Srb Selected File: nil
     State: STANDARD.
     A selected file name from `srb-file-list'.

and after I add a file and refresh the display by hiding and unhiding
the value, it shows this:

 Srb Selected File: "file1"
     State: STANDARD.
     A selected file name from `srb-file-list'.

I still see the list of radio buttons only after restarting Emacs.  So I
guess the defcustom is still wrong; do you know how to fix it?

Steve Berman




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 22:15:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 17:15:07 2012
Received: from localhost ([127.0.0.1]:54723 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2VK7-0000sm-Em
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:15:07 -0500
Received: from mail-out.m-online.net ([212.18.0.9]:38891)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <whitebox@HIDDEN>) id 1S2VJt-0000sF-Rv
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:14:55 -0500
Received: from frontend1.mail.m-online.net (unknown [192.168.8.180])
	by mail-out.m-online.net (Postfix) with ESMTP id 3Ty6Dx4sS4z4KN6q;
	Tue, 28 Feb 2012 18:23:13 +0100 (CET)
X-Auth-Info: eWXgVYfq7WRZ070FJHukIrYVRXOC1+TWXRknRcP5wh8=
Received: from igel.home (ppp-93-104-151-115.dynamic.mnet-online.de
	[93.104.151.115])
	by mail.mnet-online.de (Postfix) with ESMTPA id 3Ty6Dx1XTkz4KKFG;
	Tue, 28 Feb 2012 18:23:13 +0100 (CET)
Received: by igel.home (Postfix, from userid 501)
	id B644BCA29A; Tue, 28 Feb 2012 18:23:11 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Stephen Berman <stephen.berman@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN>
X-Yow: Dehydrated EGGS are STREWN across ROULETTE TABLES..
Date: Tue, 28 Feb 2012 18:23:11 +0100
In-Reply-To: <87obsj6l48.fsf@HIDDEN> (Stephen Berman's message of "Tue,
	28 Feb 2012 16:19:51 +0100")
Message-ID: <m2linmc1og.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

Stephen Berman <stephen.berman@HIDDEN> writes:

> On Tue, 28 Feb 2012 14:46:47 +0100 Andreas Schwab <schwab@HIDDEN> wrote:
>
>> Stephen Berman <stephen.berman@HIDDEN> writes:
>>
>>> 7. In the Customize buffer hide and then re-show the value of
>>> srb-selected-file; now the Customize buffer shows this:
>>>
>>>  Srb Selected File: "file1"
>>>      State: STANDARD. (mismatch)
>>>      A selected file name from `srb-file-list'.
>>
>> The current value does not match any of the empty set of choices.
>
> Do you mean that Custom thinks srb-file-list is still empty?

Its :type hasn't changed at all.

> (defcustom srb-selected-file (car srb-file-list)
>   "A selected file name from `srb-file-list'."
>   :type (if srb-file-list
> 	    `(radio ,@(mapcar (lambda (x) (list 'const x)) srb-file-list))) 
>   :group 'srb)
>
> then when srb-dir is empty or nonexistant, the Custom buffer shows this:
>
>  Srb Selected File: nil
>      State: STANDARD.
>      A selected file name from `srb-file-list'.

:type is nil (ie. no type).

> and after I add a file and refresh the display by hiding and unhiding
> the value, it shows this:
>
>  Srb Selected File: "file1"
>      State: STANDARD.
>      A selected file name from `srb-file-list'.

:type is still nil.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 22:12:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 17:12:22 2012
Received: from localhost ([127.0.0.1]:54716 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2VHS-0000ok-5s
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:12:22 -0500
Received: from rcsinet15.oracle.com ([148.87.113.117]:42452)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <drew.adams@HIDDEN>) id 1S2VH6-0000ns-CC
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 17:12:10 -0500
Received: from ucsinet21.oracle.com (ucsinet21.oracle.com [156.151.31.93])
	by rcsinet15.oracle.com (Sentrion-MTA-4.2.2/Sentrion-MTA-4.2.2) with
	ESMTP id q1SMBc9H028823
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Tue, 28 Feb 2012 22:11:39 GMT
Received: from acsmt358.oracle.com (acsmt358.oracle.com [141.146.40.158])
	by ucsinet21.oracle.com (8.14.4+Sun/8.14.4) with ESMTP id
	q1SMBSKi025541
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO);
	Tue, 28 Feb 2012 22:11:31 GMT
Received: from abhmt102.oracle.com (abhmt102.oracle.com [141.146.116.54])
	by acsmt358.oracle.com (8.12.11.20060308/8.12.11) with ESMTP id
	q1SMBRxr000372; Tue, 28 Feb 2012 16:11:27 -0600
Received: from dradamslap1 (/10.159.33.152)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Tue, 28 Feb 2012 14:11:26 -0800
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Andreas Schwab'" <schwab@HIDDEN>,
	"'Stephen Berman'" <stephen.berman@HIDDEN>
References: <87vcmr6r9a.fsf@HIDDEN>
	<m2sjhvax4o.fsf@HIDDEN><87obsj6l48.fsf@HIDDEN>
	<m2linmc1og.fsf@HIDDEN><87k4367spn.fsf@HIDDEN>
	<m2hayabzyo.fsf@HIDDEN>
Subject: RE: bug#10907: 24.0.94; Updating display of Customize buffer
Date: Tue, 28 Feb 2012 14:11:22 -0800
Message-ID: <5D50FB57830546E49BA986F7932928F5@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="US-ASCII"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
In-Reply-To: <m2hayabzyo.fsf@HIDDEN>
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.6157
Thread-Index: Acz2Y93I4g7ho9lURe+wSQJvwSCPXQAAV6XQ
X-Source-IP: ucsinet21.oracle.com [156.151.31.93]
X-CT-RefId: str=0001.0A090201.4F4D511B.00BC,ss=1,re=0.000,fgs=0
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

> *Note (elisp) Customization Types::
> You specify the customization type in `defcustom' with 
> the `:type' keyword.  The argument of `:type' is evaluated,
> but only once when the `defcustom' is executed, so it isn't
> useful for the value to vary.

Having this in the Elisp manual helps developers, but it is not all that helpful
for a Customize user trying to understand the behavior.

Stephen described a purely end-user interaction.  And yes, the behavior is not
obvious.  We obviously felt it sufficiently non-obvious to add that paragraph to
the Elisp manual.  End users deserve some info that helps them too understand a
bit.

At the least there seems to be an Emacs-manual doc bug here. Let's please add
something to help users navigate the labyrinth.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 21:55:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 16:55:09 2012
Received: from localhost ([127.0.0.1]:54681 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2V0l-0000PB-VK
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 16:55:09 -0500
Received: from mail-out.m-online.net ([212.18.0.9]:57352)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <whitebox@HIDDEN>) id 1S2V0Y-0000Of-LP
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 16:54:56 -0500
Received: from frontend1.mail.m-online.net (unknown [192.168.8.180])
	by mail-out.m-online.net (Postfix) with ESMTP id 3Ty73j48KHz4KMZH;
	Tue, 28 Feb 2012 19:00:17 +0100 (CET)
X-Auth-Info: KNwMlznkCEygAbtYD9VLN27DqSM3Z+IijGnjB76VJRY=
Received: from igel.home (ppp-93-104-151-115.dynamic.mnet-online.de
	[93.104.151.115])
	by mail.mnet-online.de (Postfix) with ESMTPA id 3Ty73j2gDkz4KKF2;
	Tue, 28 Feb 2012 19:00:17 +0100 (CET)
Received: by igel.home (Postfix, from userid 501)
	id BC962CA299; Tue, 28 Feb 2012 19:00:16 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Stephen Berman <stephen.berman@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
	<87k4367spn.fsf@HIDDEN>
X-Yow: Wow!  Look!!  A stray meatball!!  Let's interview it!
Date: Tue, 28 Feb 2012 19:00:15 +0100
In-Reply-To: <87k4367spn.fsf@HIDDEN> (Stephen Berman's message of "Tue,
	28 Feb 2012 18:50:28 +0100")
Message-ID: <m2hayabzyo.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

*Note (elisp) Customization Types::

       You specify the customization type in `defcustom' with the `:type'
    keyword.  The argument of `:type' is evaluated, but only once when the
    `defcustom' is executed, so it isn't useful for the value to vary.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 21:51:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 16:51:07 2012
Received: from localhost ([127.0.0.1]:54666 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2Uwr-0000Io-Rg
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 16:51:06 -0500
Received: from mailout-de.gmx.net ([213.165.64.22]:42052)
	by debbugs.gnu.org with smtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2Uwd-0000IE-84
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 16:50:54 -0500
Received: (qmail invoked by alias); 28 Feb 2012 17:50:30 -0000
Received: from i59F564CF.versanet.de (EHLO escher.home) [89.245.100.207]
	by mail.gmx.net (mp072) with SMTP; 28 Feb 2012 18:50:30 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX19u9l8cfSFuClbZq2Mz5lL84Opzgc/O1QJzSodcJA
	I71qOTdCEAQ4Js
From: Stephen Berman <stephen.berman@HIDDEN>
To: Andreas Schwab <schwab@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN> <m2sjhvax4o.fsf@HIDDEN>
	<87obsj6l48.fsf@HIDDEN> <m2linmc1og.fsf@HIDDEN>
Date: Tue, 28 Feb 2012 18:50:28 +0100
In-Reply-To: <m2linmc1og.fsf@HIDDEN> (Andreas Schwab's message of "Tue, 28
	Feb 2012 18:23:11 +0100")
Message-ID: <87k4367spn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Y-GMX-Trusted: 0
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

On Tue, 28 Feb 2012 18:23:11 +0100 Andreas Schwab <schwab@HIDDEN> wrote:

> Stephen Berman <stephen.berman@HIDDEN> writes:
>
>> On Tue, 28 Feb 2012 14:46:47 +0100 Andreas Schwab <schwab@HIDDEN> wrote:
>>
>>> Stephen Berman <stephen.berman@HIDDEN> writes:
>>>
>>>> 7. In the Customize buffer hide and then re-show the value of
>>>> srb-selected-file; now the Customize buffer shows this:
>>>>
>>>>  Srb Selected File: "file1"
>>>>      State: STANDARD. (mismatch)
>>>>      A selected file name from `srb-file-list'.
>>>
>>> The current value does not match any of the empty set of choices.
>>
>> Do you mean that Custom thinks srb-file-list is still empty?
>
> Its :type hasn't changed at all.
>
>> (defcustom srb-selected-file (car srb-file-list)
>>   "A selected file name from `srb-file-list'."
>>   :type (if srb-file-list
>> 	    `(radio ,@(mapcar (lambda (x) (list 'const x)) srb-file-list))) 
>>   :group 'srb)
>>
>> then when srb-dir is empty or nonexistant, the Custom buffer shows this:
>>
>>  Srb Selected File: nil
>>      State: STANDARD.
>>      A selected file name from `srb-file-list'.
>
> :type is nil (ie. no type).
>
>> and after I add a file and refresh the display by hiding and unhiding
>> the value, it shows this:
>>
>>  Srb Selected File: "file1"
>>      State: STANDARD.
>>      A selected file name from `srb-file-list'.
>
> :type is still nil.

I don't follow you; can (or someone else who gets it) you please
elaborate?  Thanks.

Steve Berman




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at 10907 <at> debbugs.gnu.org:


Received: (at 10907) by debbugs.gnu.org; 28 Feb 2012 13:50:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 08:50:16 2012
Received: from localhost ([127.0.0.1]:60931 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2NRX-0000uG-Ae
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 08:50:16 -0500
Received: from mail-out.m-online.net ([212.18.0.9]:55762)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <whitebox@HIDDEN>) id 1S2NRK-0000tZ-6B
	for 10907 <at> debbugs.gnu.org; Tue, 28 Feb 2012 08:50:03 -0500
Received: from frontend1.mail.m-online.net (unknown [192.168.8.180])
	by mail-out.m-online.net (Postfix) with ESMTP id 3Ty1RF4jGxz4Kgyr;
	Tue, 28 Feb 2012 14:46:49 +0100 (CET)
X-Auth-Info: caUgtl2aQLuY91S5URYDmocBmVYHaG61B2z+bJpaDTg=
Received: from igel.home (ppp-93-104-151-115.dynamic.mnet-online.de
	[93.104.151.115])
	by mail.mnet-online.de (Postfix) with ESMTPA id 3Ty1RF2Rjhz4KK5k;
	Tue, 28 Feb 2012 14:46:49 +0100 (CET)
Received: by igel.home (Postfix, from userid 501)
	id B798ACA29A; Tue, 28 Feb 2012 14:46:48 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Stephen Berman <stephen.berman@HIDDEN>
Subject: Re: bug#10907: 24.0.94; Updating display of Customize buffer
References: <87vcmr6r9a.fsf@HIDDEN>
X-Yow: LOU GRANT froze my ASSETS!!
Date: Tue, 28 Feb 2012 14:46:47 +0100
In-Reply-To: <87vcmr6r9a.fsf@HIDDEN> (Stephen Berman's message of "Tue,
	28 Feb 2012 14:07:13 +0100")
Message-ID: <m2sjhvax4o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -1.9 (-)
X-Debbugs-Envelope-To: 10907
Cc: 10907 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

Stephen Berman <stephen.berman@HIDDEN> writes:

> 7. In the Customize buffer hide and then re-show the value of
> srb-selected-file; now the Customize buffer shows this:
>
>  Srb Selected File: "file1"
>      State: STANDARD. (mismatch)
>      A selected file name from `srb-file-list'.

The current value does not match any of the empty set of choices.

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 28 Feb 2012 13:11:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 28 08:11:13 2012
Received: from localhost ([127.0.0.1]:60920 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1S2Mpl-0008RB-3A
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 08:11:13 -0500
Received: from eggs.gnu.org ([208.118.235.92]:41584)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2MpZ-0008QY-Sl
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 08:11:02 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2MmN-0004gD-Jh
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 08:07:49 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM
	autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:58697)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2MmN-0004g6-Gw
	for submit <at> debbugs.gnu.org; Tue, 28 Feb 2012 08:07:43 -0500
Received: from eggs.gnu.org ([208.118.235.92]:34509)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2MmI-0002Hp-Gv
	for bug-gnu-emacs@HIDDEN; Tue, 28 Feb 2012 08:07:43 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2Mm0-0004cE-FC
	for bug-gnu-emacs@HIDDEN; Tue, 28 Feb 2012 08:07:37 -0500
Received: from mailout-de.gmx.net ([213.165.64.22]:36985)
	by eggs.gnu.org with smtp (Exim 4.71)
	(envelope-from <stephen.berman@HIDDEN>) id 1S2Mm0-0004bs-6V
	for bug-gnu-emacs@HIDDEN; Tue, 28 Feb 2012 08:07:20 -0500
Received: (qmail invoked by alias); 28 Feb 2012 13:07:14 -0000
Received: from i59F564CF.versanet.de (EHLO escher.home) [89.245.100.207]
	by mail.gmx.net (mp012) with SMTP; 28 Feb 2012 14:07:14 +0100
X-Authenticated: #20778731
X-Provags-ID: V01U2FsdGVkX1+pqnIBycCpbkDO2eHsZ/MNJpL2u/c/zoHAbAAda/
	jMz1JuAWsd2p+u
From: Stephen Berman <stephen.berman@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 24.0.94; Updating display of Customize buffer
Date: Tue, 28 Feb 2012 14:07:13 +0100
Message-ID: <87vcmr6r9a.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Y-GMX-Trusted: 0
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 208.118.235.17
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

--=-=-=
Content-Type: text/plain

[I posted about this problem to gnu-emacs-help last week but there
hasn't been any response, so I'm adding it to the bugtracker with a more
explicit and self-contained recipe in the hope that, if it's a real bug,
it will be fixed, or if I have made a mistake, it will be pointed out.]

1. mkdir ~/srb; cd ~/srb; touch file1 file2 file3

2. emacs -Q -l path/to/srb.el # Load the attached file.

3. M-x customize-option RET srb-selected-file RET
The Customize buffer shows this, as expected:

 Srb Selected File:
 (*) file1
 ( ) file2
 ( ) file3
     State: STANDARD.
     A selected file name from `srb-file-list'.

4. rm -rf ~/srb

5. Repeat steps 2 and 3; now the Customize buffer shows this:

 Srb Selected File: nil
     State: STANDARD. (mismatch)
     A selected file name from `srb-file-list'.

This is also expected, since srb-selected-file doesn't handle nil.

6. M-x srb-add-file RET file1 RET

7. In the Customize buffer hide and then re-show the value of
srb-selected-file; now the Customize buffer shows this:

 Srb Selected File: "file1"
     State: STANDARD. (mismatch)
     A selected file name from `srb-file-list'.

If I kill the Customize buffer and repeat step 3, it still has the
same display.  What I expected to see is this: 

 Srb Selected File:
 (*) file1
     State: STANDARD.
     A selected file name from `srb-file-list'.

But only if I exit Emacs and then restart it does the Customize buffer
look like this (after loading srb.el).  I haven't been able to get this
display after carrying out steps 4-7 without restarting Emacs.  Is it
possible?  Is there a problem with my defcustom srb-selected-file, or
with the calls to custom-reevaluate-setting and custom-set-default in
srb-add-file, or have I overlooked some other custom-* function that
correctly updates the display?  Or is this a bug in the Customize API?
I'd be grateful for any help.


In GNU Emacs 24.0.94.1 (i686-suse-linux-gnu, GTK+ Version 2.24.7)
 of 2012-02-28 on escher
Windowing system distributor `The X.Org Foundation', version 11.0.11004000
Configured using:
 `configure '--without-toolkit-scroll-bars' 'CFLAGS=-g''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=local
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t


--=-=-=
Content-Type: text/x-emacs-lisp
Content-Disposition: attachment; filename=srb.el
Content-Description: test file

(defgroup srb nil
  "srb group.")

(defcustom srb-dir "~/srb/"
  "Directory of files whose names are members of `srb-file-list'."
  :type 'directory
  :group 'srb)

(defvar srb-file-list (if (file-exists-p srb-dir)
			  (directory-files srb-dir nil
					   "^[^.]+")) ; Don't include "." or ".."
  "List of names of files in `srb-dir'.")

(defcustom srb-selected-file (car srb-file-list)
  "A selected file name from `srb-file-list'."
  :type `(radio ,@(mapcar (lambda (x) (list 'const x)) srb-file-list))
  :group 'srb)

(defun srb-add-file ()
  "Add a file name to `srb-file-list' and update `srb-selected-file'."
  (interactive)
  (unless (file-exists-p srb-dir)
    (make-directory srb-dir))
  (let ((file (read-from-minibuffer "Enter a file name: ")))
    (with-current-buffer (get-buffer-create file)
      (erase-buffer)
      (write-region (point-min) (point-max)
		    (concat srb-dir file) nil 'nomessage nil t)
      (kill-buffer file)))
  (setq srb-file-list (directory-files srb-dir nil "^[^.]+"))
  (custom-reevaluate-setting 'srb-selected-file)
  (custom-set-default 'srb-file (symbol-value 'srb-selected-file)))

(provide 'srb)

--=-=-=--




Acknowledgement sent to Stephen Berman <stephen.berman@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#10907; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 25 Nov 2019 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.